# チェストの中身を変換する

#アイテム化可能フラグをtrueにしておく
#falseになる条件は以下の3つ
#1.チェスト内に所定の文字アイテム以外が入っている
#2.文字アイテムのスタック数が異なっている
#3.単語が存在しない
data modify storage minecraft:sukyakura Creative2.able set value true

#チェストの中身を調べてリスト化(このときに空箱の場合と文字アイテム以外が入っていた場合とスタック数が異なっていた場合はアイテム化可能フラグをfalseにする)
function creative2:charlist

#sk_cre2_iを0にしておく(Creative2.ableがtrueのときは単語チェック後に0または1になってる)
scoreboard players set #Alice sk_cre2_i 0

#sk_cre2_cntが-1以外であり(チェストには中身が入っていた)、Creative2.charsが[]であり(今までに読み取れたアイテムがない)、Creative2.Itemsが[]である(まだ調べていないアイテムがない)場合は、文字アイテムに変換する
execute unless score #Alice sk_cre2_cnt matches -1 unless data storage minecraft:sukyakura Creative2.chars[0] unless data storage minecraft:sukyakura Creative2.Items[0] run function creative2:makechars

#単語チェック
execute if data storage minecraft:sukyakura {Creative2:{able:true}} run data modify storage minecraft:sukyakura Creative2.Items set value [{Slot:0b,id:"",Count:0b}]
execute if data storage minecraft:sukyakura {Creative2:{able:true}} store result storage minecraft:sukyakura Creative2.Items[0].Count byte 1 run scoreboard players get #Alice sk_cre2_cnt
execute if data storage minecraft:sukyakura {Creative2:{able:true}} run data modify storage minecraft:sukyakura Creative2.temp set from storage minecraft:sukyakura Creative2.database
execute if data storage minecraft:sukyakura {Creative2:{able:true}} run scoreboard players set #Alice sk_cre2_j 0
execute if data storage minecraft:sukyakura {Creative2:{able:true}} run function creative2:divcheck
execute if data storage minecraft:sukyakura {Creative2:{able:true}} if score #Alice sk_cre2_j matches 0 run data modify storage minecraft:sukyakura Creative2.able set value false

#チェストの中身を変換
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] run data modify block ~ ~ ~ Items set from storage minecraft:sukyakura Creative2.Items
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox2,limit=1] run data modify block ~ ~ ~ Items set value []

#アイテムから文字にして成功しているならfalseをtrueにする
execute if score #Alice sk_cre2_i matches -1 run data modify storage minecraft:sukyakura Creative2.able set value true

#パーティクルとサウンド
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] positioned ~1.0 ~ ~ if entity @e[tag=sk_wordbox2,distance=..0.01] run particle minecraft:witch ~-0.5 ~ ~ 0.5 0.25 0.25 1.0 100 force
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] positioned ~-1.0 ~ ~ if entity @e[tag=sk_wordbox2,distance=..0.01] run particle minecraft:witch ~0.5 ~ ~ 0.5 0.25 0.25 1.0 100 force
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] positioned ~ ~ ~1.0 if entity @e[tag=sk_wordbox2,distance=..0.01] run particle minecraft:witch ~ ~ ~-0.5 0.25 0.25 0.5 1.0 100 force
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] positioned ~ ~ ~-1.0 if entity @e[tag=sk_wordbox2,distance=..0.01] run particle minecraft:witch ~ ~ ~0.5 0.25 0.25 0.5 1.0 100 force
execute if data storage minecraft:sukyakura {Creative2:{able:true}} positioned as @e[tag=sk_wordbox1,limit=1] facing entity @e[tag=sk_wordbox2,limit=1] feet positioned ^ ^ ^0.5 run playsound minecraft:entity.iron_golem.damage master @a ~ ~ ~ 2.0 2.0 0.0
execute if data storage minecraft:sukyakura {Creative2:{able:false}} positioned as @e[tag=sk_wordbox1,limit=1] facing entity @e[tag=sk_wordbox2,limit=1] feet positioned ^ ^ ^0.5 run playsound minecraft:block.note_block.bass master @a ~ ~ ~ 2.0 0.5 0.0
