# メイン処理

#初期地点の本が4ページになるとボタン出現
execute if data storage minecraft:sukyakura {Creative2:{event:{page:false}}} if data block 21 130 20 {Page:3} run setblock 21 131 20 minecraft:polished_blackstone_button[face=wall,facing=west,powered=false]
execute if data storage minecraft:sukyakura {Creative2:{event:{page:false}}} if data block 21 130 20 {Page:3} run particle minecraft:witch 21.0 131.5 20.5 0.0 0.2 0.2 1.0 200 force
execute if data storage minecraft:sukyakura {Creative2:{event:{page:false}}} if data block 21 130 20 {Page:3} run playsound minecraft:entity.iron_golem.death master @a 21.0 131.5 20.5 2.0 2.0 0.0
execute if data storage minecraft:sukyakura {Creative2:{event:{page:false}}} if data block 21 130 20 {Page:3} run data modify storage minecraft:sukyakura Creative2.event.page set value true

#初期地点でボタンを押すとtpしてタイトル表示
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run teleport @a 7.0 2.0 7.0 -90.0 0.0
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run title @a title [{"text":"Creative2","bold":"true","color":"dark_aqua"}]
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run title @a subtitle [{"text":"developed by Sukyakura","color":"blue"}]
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run playsound minecraft:entity.iron_golem.hurt master @a 7.0 6.0 7.0 10.0 2.0 0.0
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run spawnpoint @a 7 2 7 -90.0
execute if data storage minecraft:sukyakura {Creative2:{event:{start:false}}} if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run recipe give @a *
execute if block 21 131 20 minecraft:polished_blackstone_button[powered=true] run data modify storage minecraft:sukyakura Creative2.event.start set value true
execute if block 21 131 20 minecraft:polished_blackstone_button[powered=false] run data modify storage minecraft:sukyakura Creative2.event.start set value false

#リセットボタンを押すとリセット
execute if data storage minecraft:sukyakura {Creative2:{event:{reset:false}}} if block 10 3 6 minecraft:stone_button[powered=true] run function creative2:reset
execute if data storage minecraft:sukyakura {Creative2:{event:{reset:false}}} if block 10 3 6 minecraft:stone_button[powered=true] run data modify block 10 2 6 Items set from storage minecraft:sukyakura Creative2.question[0].chest[0]
execute if data storage minecraft:sukyakura {Creative2:{event:{reset:false}}} if block 10 3 6 minecraft:stone_button[powered=true] run data modify block 10 2 7 Items set from storage minecraft:sukyakura Creative2.question[0].chest[1]
execute if data storage minecraft:sukyakura {Creative2:{event:{reset:false}}} if block 10 3 6 minecraft:stone_button[powered=true] run particle minecraft:spit 7.0 6.0 7.0 4.0 4.0 4.0 1.0 500 force
execute if data storage minecraft:sukyakura {Creative2:{event:{reset:false}}} if block 10 3 6 minecraft:stone_button[powered=true] run playsound minecraft:block.end_portal_frame.fill master @a 7.0 6.0 7.0 10.0 1.0 0.0
execute if block 10 3 6 minecraft:stone_button[powered=true] run data modify storage minecraft:sukyakura Creative2.event.reset set value true
execute if block 10 3 6 minecraft:stone_button[powered=false] run data modify storage minecraft:sukyakura Creative2.event.reset set value false

#変換ボタンを押すと変換
execute if data storage minecraft:sukyakura {Creative2:{event:{convert:false}}} if block 10 3 7 minecraft:polished_blackstone_button[powered=true] run function creative2:convert
execute if block 10 3 7 minecraft:polished_blackstone_button[powered=true] run data modify storage minecraft:sukyakura Creative2.event.convert set value true
execute if block 10 3 7 minecraft:polished_blackstone_button[powered=false] run data modify storage minecraft:sukyakura Creative2.event.convert set value false

#正しいアイテムが納品されると次のステージへ
function creative2:solvecheck
execute if data storage minecraft:sukyakura {Creative2:{event:{solve:false}}} run function creative2:nextstage

#クリア
execute unless data storage minecraft:sukyakura Creative2.question[0] if score #Alice sk_cre2_time matches 0..59 positioned as @a run particle minecraft:cloud ~ ~1.0 ~ 1.0 2.0 1.0 1.0 300 force
execute unless data storage minecraft:sukyakura Creative2.question[0] if score #Alice sk_cre2_time matches 0.. run scoreboard players remove #Alice sk_cre2_time 1
execute if score #Alice sk_cre2_time matches 0 run teleport @a 18.5 134.0 20.5 -90.0 0.0
execute if score #Alice sk_cre2_time matches 0 run title @a title [{"text":"Congratulations!!!","bold":"true","color":"yellow"}]
execute if score #Alice sk_cre2_time matches 0 run title @a subtitle [{"text":"Thank you for playing!!","color":"gold"}]
execute if score #Alice sk_cre2_time matches 0 run playsound minecraft:ui.toast.challenge_complete master @a 18.5 136.0 20.5 2.0 1.0 0.0
execute if score #Alice sk_cre2_time matches 0 run particle minecraft:cloud 18.5 136.0 20.5 3.0 3.0 3.0 1.0 3000 force
execute if score #Alice sk_cre2_time matches 0 run effect clear @a
execute if score #Alice sk_cre2_time matches 0 if data storage minecraft:sukyakura {Creative2:{event:{omake:true}}} run data modify block 22 134 20 Book.tag.pages[-1] set value '{"text":"---おまけ問題---\\n\\nゲームクリアおめでとうございます！！！\\nこの問題は簡易化しなければ、卵孵化の運ゲーと鶏の成長待機地獄、そして羽ドロップの運ゲーがある超鬼畜仕様でした()\\nちなみに運ゲーはセーブデータのバックアップで対処できるので決して無理ゲーではない"}'
execute if score #Alice sk_cre2_time matches 0 if data storage minecraft:sukyakura {Creative2:{event:{omake:true}}} run data modify block 21 134 20 Text1 set value '{"text":"おまけ問題 Cleared."}' 

#暗視
execute if score #Alice sk_cre2_time matches 100 run effect give @a minecraft:night_vision 1000000 255 true

#辞書変化
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem run data modify storage minecraft:sukyakura Creative2.temp set from storage minecraft:sukyakura Creative2.database
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem run scoreboard players operation #Alice sk_cre2_i = #Alice sk_cre2_item
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem unless score #Alice sk_cre2_i matches 0 run function creative2:dictionary
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem run data modify entity @e[type=minecraft:glow_item_frame,tag=sk_preview,limit=1] Item.id set from storage minecraft:sukyakura Creative2.temp[-1].id
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem run data modify block 20 128 20 Text1 set value '{"storage":"sukyakura","nbt":"Creative2.temp[-1].div","interpret":true}'
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem run data modify entity @e[type=minecraft:glow_item_frame,tag=sk_preview,limit=1] Item.tag.display.Name set from block 20 128 20 Text1
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem positioned as @e[type=minecraft:glow_item_frame,tag=sk_preview,limit=1] run particle minecraft:witch ~ ~ ~ 0.0 0.25 0.25 1.0 50 force
execute unless score #Alice sk_cre2_item = #Alice sk_cre2_pitem positioned as @e[type=minecraft:glow_item_frame,tag=sk_preview,limit=1] run playsound minecraft:entity.experience_orb.pickup master @a ~ ~ ~ 5.0 2.0 0.0
scoreboard players operation #Alice sk_cre2_pitem = #Alice sk_cre2_item

#ニワトリ
execute if data storage minecraft:sukyakura {Creative2:{event:{easy:true}}} as @e[type=minecraft:chicken] run function creative2:chicken
execute if data storage minecraft:sukyakura {Creative2:{event:{easy:true}}} run function creative2:egg
execute if data storage minecraft:sukyakura {Creative2:{event:{easy:true}}} as @e[nbt=!{DeathLootTable:"creative2:entities/chicken"}] run data modify entity @s DeathLootTable set value "creative2:entities/chicken"
